﻿class AuteursController < ApplicationController



##### Remise à blanc des erreurs avant affichage de l'écran de modif/ajout
# sans cela, en cas d'abandon d'une transaction, on pourrait avoir conservé un message précédent
before_action only: [:ajout, :modif, :controle] do
  	flash[:meserr]=""
end



##### Liste des auteurs
def liste

	@aut=Auteur.find(:all, :order => "autabr")

	# affichage avec le layout administrateur, qui n'est pas celui par défaut
	# on devrait écrire render :liste, layout: "administrateur" mais liste est inutile, puisqu'identique à l'action
	render layout: "administrateur"

end



##### Appel du formulaire d'ajout d'un auteur
def ajout

	@newaut=Auteur.new
	render :modif

end



##### Validation de l'ajout d'un auteur
def ajoutvalid

	# paramètre reçu du formulaire d'ajout
	# {"utf8"=>"?", "authenticity_token"=>"KDjHrinphpE6HFD8dDfS/aemup24e2RHLGMRHEC8JqE=", "auteur"=>{"autnom"=>"x", "autabr"=>"w"}, "commit"=>"Valider", "action"=>"ajoutvalid", "controller"=>"auteurs"} 	
	

	### Initialiser la zone de réception des données
	@newaut=Auteur.new
	
	### Controler les données
	if controle == 1 then
		
		# si erreur afficher directement la vue (avec message d'erreur renseigné) sans repasser par l'action ajout qui réinitialise @newaut
		render :modif
		return

	else
	
		# Ecriture par new + save
		# @aut=Auteur.new
		# @aut[:autabr]=params[:auteur][:autabr]	
		# @aut[:autnom]=params[:auteur][:autnom]
		# @aut.save
	
		# Ecriture par create
		Auteur.create(:autabr => params[:auteur][:autabr].upcase, :autnom=>params[:auteur][:autnom])

		# equivalent ci-dessus (sauf upcase meme si css=text-transform: uppercase : ok à la saisie, mais transmis en minuscules).
		# Auteur.create(params[:auteur])
	
		# Réafficher la liste
		redirect_to lister_les_auteurs_path

	end

end



##### Validation de la suppression d'un auteur
def supprvalid
	
	### Suppression. Le param recu a la forme {"action"=>"supprvalid", "controller"=>"auteurs", "format"=>"6"}  à cause du lien qui passe un paramètre au lieu d'une url
	Auteur.delete(params[:format])

	### Réafficher la liste
	redirect_to lister_les_auteurs_path

	# pour debugger les paramètres de la suppression
	# @aut=Auteur.find(:all, :order => "autabr")
	# @zgtitre=params[:format]
	# render "/auteurs/liste"
end



##### Appel du formulaire de modification d'un auteur
def modif

	# Appel par lancer_maj_dun_auteur(xaut.id) = @newaut=Auteur.find(params[:format])
	# Appel par lancer_maj_dun_auteur/xaut.id : on récupère un paramètre id et non format (voir cas de la suppression)
	@newaut=Auteur.find(params[:id])
	render :modif # inutile car meme nom que l'action

end



##### Validation de la modification d'un auteur
def modifvalid

	### paramètre reçu du formulaire de modif
	# {"utf8"=>"?", "authenticity_token"=>"KDjHrinphpE6HFD8dDfS/aemup24e2RHLGMRHEC8JqE=", "auteur"=>{"id"=>"2", "autnom"=>"Dino BUZZATI", "autabr"=>"BUZZATI"}, "commit"=>"Valider", "action"=>"modifvalid", "controller"=>"auteurs"} 

	### Initialiser la zone de réception des données
	@newaut=Auteur.find(params[:auteur][:id])
	
	### Controler les données
	if controle == 1 then
		
		# afficher directement la vue sans repasser par l'action modif qui recharge @newaut à l'initial
		render :modif
		return

	else

		@newaut.save
		redirect_to lister_les_auteurs_path

	end


	

end



##### Contrôle des données avant mise à jour de la base
def controle

	### Affecter les valeurs du formulaire à l'objet
	# s'il n' a pas d'erreur, les données seront chargées
	# s'il y a erreur, les données saisies seront réaffichées et non celles de départ
	@newaut[:autabr]= params[:auteur][:autabr].upcase
	@newaut[:autnom]= params[:auteur][:autnom]

	### Controler les données
	inderr=0

	# nom obligatoire (pourrait etre fait par le modèle)
	if (@newaut[:autnom]==="" && inderr ==0) then
		flash[:meserr]="Nom obligatoire"
		inderr=1
	end

	# vérification que le nom court est unique
	if (inderr==0) then
		aut=Auteur.find(:all, :conditions => ['autabr = ? AND id <>  ?', params[:auteur][:autabr].upcase, params[:auteur][:id]])
		if ! aut.blank? then
			flash[:meserr]="Nom court existe pour un autre auteur"
			inderr=1
		end 
	end

	x=inderr # pour affecter à la fonction la valeur de inderr

end




end
