﻿class CategoriesController < ApplicationController

##### La structure est identique à celle de auteurs. Voir ce dernier contrôleur pour des commentaires complets.

##### Remise à blanc des erreurs avant affichage de l'écran de modif/ajout
before_action only: [:ajout, :modif, :controle] do
  	flash[:meserr]=""
end



##### Liste des categories
def liste

	@cat=Categorie.find(:all, :order => "catlib")
	render :liste

end



##### Appel du formulaire d'ajout
def ajout

	@newcat=Categorie.new
	render :modif

end



##### Validation de l'ajout
def ajoutvalid

	### Initialiser la zone de réception des données
	@newcat=Categorie.new
	
	### Controler les données
	if controle == 1 then
		
		# afficher directement la vue sans repasser par l'action ajout qui réinitialise @newaut
		render :modif
		return

	else
	
		# Ecriture par create
		Categorie.create(:catlib => params[:categorie][:catlib])

		# Réafficher la liste
		redirect_to lister_les_categories_path

	end

end



##### Validation de la suppression
def supprvalid
	
	### Suppression
	Categorie.delete(params[:format])

	### Réafficher la liste
	redirect_to lister_les_categories_path

end



##### Appel du formulaire de modification
def modif

	@newcat=Categorie.find(params[:id])
	render :modif 

end



##### Validation de la modification
def modifvalid

	### Initialiser la zone de réception des données
	@newcat=Categorie.find(params[:categorie][:catid])
	
	### Controler les données
	if controle == 1 then
		
		# afficher directement la vue sans repasser par l'action modif qui recharge @newaut à l'initial
		render :modif
		return

	else

		@newcat.save
		redirect_to lister_les_categories_path

	end


	

end



##### Contrôle des données avant mise à jour de la base
def controle

	### Affecter les valeurs du formulaire à l'objet 
	@newcat[:catlib]= params[:categorie][:catlib]

	### Controler les données
	inderr=0

	# nom obligatoire (pourrait etre fait par le modèle)
	if (@newcat[:catlib]==="" && inderr ==0) then
		flash[:meserr]="Libellé obligatoire"
		inderr=1
	end


	x=inderr

end




end
