Biblio::Application.routes.draw do

#####  Page d'accueil
# l'url localhost:3000 affiche automatiquement le controleur menu, action page_accueil
# equivalent  get '/', to: 'menu#accueil'
root 'menu#page_accueil'

##### Accs  la page d'accueil  partir du menu
get "page_accueil" => "menu#page_accueil" 




#####  Auteurs
# l'url "lister_les_auteurs" pointe sur le controleur auteurs, action liste
# dans les vues, le lien s'effectue sur la variable automatique "lister_les_auteurs_path"
get "lister_les_auteurs" => "auteurs#liste"

# appel du formulaire d'ajout d'un auteur, sans changement de nom
get "auteurs/ajout"

# validation de l'ajout d'un auteur
#post "valider_ajout_dun_auteur" => "auteurs#ajoutvalid"
match "valider_ajout_dun_auteur" => "auteurs#ajoutvalid", :via => :post

# validation de la suppression d'un auteur
match "valider_suppression_dun_auteur" => "auteurs#supprvalid", :via => :get

# appel du formulaire de modification d'un auteur
# utilise pour lancer_maj_dun_auteur(xaut.id) et obligatoire pour la seconde mthode aussi
match "lancer_maj_dun_auteur" => "auteurs#modif", :via => :get
# utilise pour lancer_maj_dun_auteur/xaut.id (url au lieu de paramtre)
match "lancer_maj_dun_auteur/:id" => "auteurs#modif", :via => :get

# validation de la modification d'un auteur
match "valider_maj_dun_auteur" => "auteurs#modifvalid", :via => :post	




#####  Catgories
# l'url "lister_les_categories" pointe sur le controleur categories, action liste
get "lister_les_categories" => "categories#liste"

# appel du formulaire d'ajout
get "categories/ajout"

# validation de l'ajout
match "valider_ajout_dune_vategorie" => "categories#ajoutvalid", :via => :post

# validation de la suppression
match "valider_suppression_dune_categorie" => "categories#supprvalid", :via => :get

# appel du formulaire de modification
match "lancer_maj_dune_categorie" => "categories#modif", :via => :get
match "lancer_maj_dune_categorie/:id" => "categories#modif", :via => :get

# validation de la modification
match "valider_maj_dune_categorie" => "categories#modifvalid", :via => :post	




#####  Livres
get "lister_les_livres" => "livres#liste"
get "livres/ajout"
match "valider_ajout_dun_livre" => "livres#ajoutvalid", :via => :post
match "lancer_maj_dun_livre" => "livres#modif", :via => :get
match "lancer_maj_dun_livre/:id" => "livres#modif", :via => :get
match "valider_maj_dun_livre" => "livres#modifvalid", :via => :post	
match "valider_suppression_dun_livre" => "livres#supprvalid", :via => :get
match "selectionner_des_livres" => "livres#recherche", :via => :get
match "valider_selection_des_livres" => "livres#recherchevalid", :via => :post
match "effacer_selection_des_livres" => "livres#rechercheraz", :via => :get


#####  Chargement de la base
get "chargement/charg"



end
